// Copyright 2024 Matthew Rich <matthewrich.conf@gmail.com>. All rights reserved.

package data

import (
	"errors"
)

var (
	ErrConfigUndefinedName = errors.New("Config block is missing a defined name")
)


type Block interface {
	Identifier
	ConfigurationType() TypeName
	Loader
	Validator
	NewConfiguration(uri *string) error
	ConfigurationValueGetter
	Configuration() Configuration
	Clone() Block
}

